
const St = imports.gi.St;
const Main = imports.ui.main;
const Tweener = imports.ui.tweener;
const GLib = imports.gi.GLib;

let text, state, button, PAID;

function _hideHello() {
    Main.uiGroup.remove_actor(text);
    text = null;
}

function _toggle() {

    if (state == 0) {
        PAID = GLib.spawn_command_line_sync('pactl load-module module-loopback latency_msec=1');
        text = new St.Label({ style_class: 'helloworld-label', text: "PulseAudio Loopback ON, MID:" + PAID[1]});
        state = 1;
        
    }
    else {
        text = new St.Label({ style_class: 'helloworld-label', text: "PulseAudio Loopback OFF" });
        state = 0;
        GLib.spawn_command_line_sync('pactl unload-module ' + PAID[1]);
    }

    

    Main.uiGroup.add_actor(text);
    text.opacity = 255;

    let monitor = Main.layoutManager.primaryMonitor;

    text.set_position(monitor.x + Math.floor(monitor.width / 2 - text.width / 2),
                      monitor.y + Math.floor(monitor.height / 2 - text.height / 2));

    Tweener.addTween(text,
                     { opacity: 0,
                       time: 5,
                       transition: 'easeOutQuad',
                       onComplete: _hideHello });
}

function init() {
    button = new St.Bin({ style_class: 'panel-button',
                          reactive: true,
                          can_focus: true,
                          x_fill: true,
                          y_fill: false,
                          track_hover: true });
    let icon = new St.Icon({ icon_name: 'system-run-symbolic',
                             style_class: 'system-status-icon' });

    button.set_child(icon);
    button.connect('button-press-event', _toggle);
    state = 0;
}

function enable() {
    Main.panel._rightBox.insert_child_at_index(button, 0);
}

function disable() {
    Main.panel._rightBox.remove_child(button);
}
